#include <pic.h>
__CONFIG (INTIO & UNPROTECT & LVPDIS & BOREN & MCLRDIS & PWRTEN & WDTDIS);

__EEPROM_DATA(1,0xa1,0x70,0x6f,0xbc,0xba,0x6f,0x63);
__EEPROM_DATA(0xbf,0xc4,2,0xa0,0x61,0xbb,0x61,0xbd);
__EEPROM_DATA(0x63,3,0x54,0x65,0xbc,0xb2,0x70,0x20);
__EEPROM_DATA(0xbd,0xb8,0xb7,0xba,0xb8,0x65,4,0x54);

__EEPROM_DATA(0x65,0xbc,0xb2,0x70,0x20,0xb3,0xc3,0x63);
__EEPROM_DATA(0x6f,0xba,0xb8,0x65,5,0x50,0x65,0xb6);
__EEPROM_DATA(0xb8,0xbc,6,0x6f,0xb2,0xc3,0xc0,0xbd);
__EEPROM_DATA(0xc3,0xb9,7,0x70,0x61,0x63,0xc1,0xb8);

__EEPROM_DATA(0x70,0x65,0xbd,0xbd,0xc3,0xb9,8,0xbe);
__EEPROM_DATA(0x63,0x65,0xb3,0xe3,0x6f,0x63,0xbf,0x65);
__EEPROM_DATA(0x70,0x65,0x6f,9,0xbc,0x6f,0xbd,0x6f);
__EEPROM_DATA(10,0x42,0x78,0x6f,0xe3,11,0xbb,0xb8);

__EEPROM_DATA(0xbd,0x65,0xb9,0xbd,0xc3,0xb9,12,0xbe);
__EEPROM_DATA(0x70,0xb8,0xb5,0xbc,0xbd,0xb8,0xba,13);
__EEPROM_DATA('N','a','s','t','y','a',' ',14);
__EEPROM_DATA(50,32,8,8,1,1,0,0);


void podgot (void); //  
void hd44_ini (void); //  HD44780
void ee_rw_param (unsigned char x); // RW-
void anima_nabor_1 (void); // -1

#define led RA4
bit stb; //   (  )

unsigned int rc5 (void); //   -
unsigned char ir;        //   -
void encoder (void);     //   

void ir_int  (void); //  -
void enc_int (void); //  
void key_int (void); //  

unsigned int  ir_ta; //   -
unsigned int vol_ta; //    


interrupt void xxx (void)
{
if (INTF & INTE) //  -
{ir = (rc5()& 0b00000000111111);} 
if (RBIF & RBIE) //  
{encoder ();}
INTF=0;RBIF=0;   //  
}

void main (void) { //  
vol_ta=0xffff; do {asm("nop");} while (vol_ta--);
podgot ();  //  
hd44_ini(); //  
ee_rw_param ('r'); //    
anima_nabor_1(); //   
GIE=1;  //   
while(1)   //   
{
led = 1-stb;
if ( ir_ta!=0)  ir_ta--; // ""  
if (vol_ta!=0) vol_ta--; // ""  

ir_int ();  //  -
enc_int ();  //  
key_int ();  //  
}}

void podgot (void)
{INTCON = 0;  //   
TRISA = 0b00000000; TRISB = 0b11111001;
// RB0  -, RB3:RB4  , RB5:RB7  
CMCON = 0x07; //   (    )
PORTA = 0; PORTB = 0; 
//   
INTE=1; //    RB0/INT (1-, 0-)
INTF=0; //      RB0/INT
INTEDG=0;//    

RBIE=1; //    RB4:RB7 (1-, 0-)
RBIF=0; //      RB4:RB7
}


#define rs  RA2 //  
#define com rs=0 //    (IR)
#define dat rs=1 //    (DR)

void hd44_out (unsigned char y); 
void hd44_clr (void); //  
void anima_pause (void); //  
void anima_on  (void); //  " " 
void anima_off (void); //   
void anima_fraza_1 (void); // -1
void anima_fraza_2 (void); // -2
void anima_nabor_1 (void); // 1- 
void anima_nabor_2 (void); // 2- 

void anima_nabor_1 (void) // 1-  
{hd44_clr();    //  
//anima_on();   //    
anima_fraza_1();//    
//anima_off();  //    
}

void anima_nabor_2 (void) // 2-  
{hd44_clr();    //  
anima_on();     //    
anima_fraza_2();//    
anima_off();    //    
hd44_clr();     //  
}

void anima_fraza_1 (void)
{
hd44_out(0x7); anima_pause();
hd44_out(' '); //anima_pause();
hd44_out('$'); anima_pause();
hd44_out('Y'); anima_pause();
hd44_out('P'); anima_pause();
hd44_out('E'); anima_pause();
hd44_out('R'); anima_pause();
hd44_out(' '); //anima_pause();
hd44_out('N'); anima_pause();
hd44_out('A'); anima_pause();
hd44_out('$'); anima_pause();
hd44_out('T'); anima_pause();
hd44_out('Y'); anima_pause();
hd44_out('A'); anima_pause();
hd44_out(' '); //anima_pause();
hd44_out(0x7); anima_pause();
anima_pause();
anima_pause();
anima_pause();
}

void anima_fraza_2 (void)
{
hd44_out('G'); anima_pause();
hd44_out('O'); anima_pause();
hd44_out('O'); anima_pause();
hd44_out('D'); anima_pause();
hd44_out(' '); //anima_pause();
hd44_out('B'); anima_pause();
hd44_out('Y'); anima_pause();
hd44_out('E'); anima_pause();
hd44_out(','); anima_pause();
hd44_out(' '); //anima_pause();
hd44_out('B'); anima_pause();
hd44_out('A'); anima_pause();
hd44_out('B'); anima_pause();
hd44_out('Y'); anima_pause();
hd44_out(' '); //anima_pause();
hd44_out('!'); anima_pause();
anima_pause();
anima_pause();
anima_pause();
}

void hd44_clrn (unsigned char y); //   
void hd44_out (unsigned char y); //   
unsigned char vol,bal,bas,tre,mod,inp,re1,re2; //  

void ee_rw_param (unsigned char x){
if (x == 'r'){
vol = EEPROM_READ(120);
bal = EEPROM_READ(121);
bas = EEPROM_READ(122);
tre = EEPROM_READ(123);
mod = EEPROM_READ(124);
inp = EEPROM_READ(125);
re1 = EEPROM_READ(126);
re2 = EEPROM_READ(127);}

if (x == 'w'){
EEPROM_WRITE(120,vol);
EEPROM_WRITE(121,bal);
EEPROM_WRITE(122,bas);
EEPROM_WRITE(123,tre);
EEPROM_WRITE(124,mod);
EEPROM_WRITE(125,inp);
EEPROM_WRITE(126,re1);
EEPROM_WRITE(127,re2);}
}

#define enc_A RB4 //  ,  
#define enc_B RB3 //  ,   

#define key_x1 RA0
#define key_x2 RA7
#define key_x3 RA6
#define key_y1 RB7
#define key_y2 RB6
#define key_y3 RB5

unsigned char key_rez; //  

void key (void)
{
GIE=0; //   
key_x1 = 0;
if (key_y1 == 0) key_rez = 1;
if (key_y2 == 0) key_rez = 2;
if (key_y3 == 0) key_rez = 3;
key_x1 = 1;
key_x2 = 0;
if (key_y1 == 0) key_rez = 4;
if (key_y2 == 0) key_rez = 5;
if (key_y3 == 0) key_rez = 6;
key_x2 = 1;
key_x3 = 0;
if (key_y1 == 0) key_rez = 7;
if (key_y2 == 0) key_rez = 8;
if (key_y3 == 0) key_rez = 9;
key_x3 = 1;
GIE=1;
}

#define db7 RA6 //    DB4
#define db6 RA7 //    DB5
#define db5 RA0 //    DB6
#define db4 RA1 //    DB7
#define e   RA3 //    
#define rs  RA2 //  
#define led RA4

#define com rs=0 //    (IR)
#define dat rs=1 //    (DR)

bit mut; //   (  )
bit stb; //   (  )

void hd44_ini (void); //  HD44780
void hd44_out (unsigned char y); //   
void hd44_str (void); //    
void hd44_nop (void); //   100 
void hd44_clr (void); //  
void hd44_clrn (unsigned char y); //   
void hd44_usr (void); //     |
void hd44_ygo (unsigned char y); //      
void hd44_svet (void); // 

// ===    
void hd44_cyr (unsigned char y)
{unsigned char x;
if (y == 'A') x = 0x41;
if (y == '') x = 0xa0;
if (y == '') x = 0x42;
if (y == '') x = 0xa1;
if (y == '') x = 0xe0;
//...  ..
hd44_out(x);
}

#define scl RB1
#define sda RB2

void i2c_sta (void); //  
void i2c_out (unsigned char x); //  
void i2c_sto (void); //  
void i2c_nop (void); //  
void i2c_str (void); //  

void i2c_str (void)
{scl = 1; i2c_nop(); scl =0;}

void i2c_sto (void)
{scl = 1; i2c_nop(); sda = 1;}

void osn_int (void); //   
void mute (void); //  mute
bit  mut; //   ()
void standby (void); //  
bit  stb; //  
unsigned char param, vall; //   
unsigned char param_old, vall_old; //    
unsigned char vol,bal,bas,tre,mod,inp,re1,re2; //  

unsigned char ir; //   -
unsigned char ir_pro; //   -
unsigned int ir_ta ; //   -
unsigned int vol_ta ; //    

void ir_int (void)
{
//   
if (param!=1) {if (vol_ta==0) {param=1;osn_int();}}

if (ir!=0) 
 {
GIE=0;
if (ir_pro==ir) 
   { //  
if (ir==32) {param++;osn_int();}  // +
if (ir==33) {param--;osn_int();}  // -
if ((ir==16)|(ir==22)) {vall++;osn_int();}   // +
if ((ir==17)|(ir==21)) {vall--;osn_int();}   // -

if (ir==23) {param=1;osn_int();}  // "OK"  
if (ir==43) {param=2;osn_int();}  //   
if (ir==44) {param=3;osn_int();}  //    
if (ir==45) {param=4;osn_int();}  //    
if (ir==46) {param=5;osn_int();}  //   
if ((ir==56)|(ir==35)) {param=6;osn_int();}  // TV/AV   

if (ir==13) {mute();}    // mute
if (ir==12) {standby();} // standby
  } ir_pro=ir; 
ir = 0;
GIE=1;
 }
}

bit enc_napr;  //  : 1-, 0-
bit enc_act;   //  : 1-, 0- 

void enc_int (void)
{if  (enc_act  == 1)
{ GIE=0;
(enc_napr == 1) ? vall++ : vall--;
 osn_int(); enc_act=0;  
  GIE=1;
}}

void key_int (void)
{unsigned int key_tmp;
    key ();
if (key_rez!=0) { //   
if (key_rez == 1) {standby();} // 
if (key_rez == 3) {mute();}    // 
if (key_rez == 4) {vall++ ;osn_int();}  //  +
if (key_rez == 6) {vall-- ;osn_int();}  //  -
if (key_rez == 2) {param++;osn_int();}  //  +
if (key_rez == 5) {param--;osn_int();}  //  -
    key_rez =  0;
key_tmp=0xfff; do {asm("nop");} while (key_tmp--);
}
}